view admin/quick-install-emacs @ 94414:d86cb59eea9f

2008-04-27 Carsten Dominik <dominik@science.uva.nl> * org/org.el (org-html-level-start): Always have id's in HTML (org-export-as-html): Use `org-link-protocols' to retrieve the export form of the link. (org-add-link-type): Final parameter renamed from PUBLISH. Better documentation of how it is to be used. Avoid double entries for the same link type. (org-add-link-props): New function. (org-modules-loaded): New variable. (org-load-modules-maybe, org-set-modules): New function. (org-modules): New option. (org-mode, org-cycle, orgstruct-mode, org-run-like-in-org-mode) (orgtbl-mode, org-store-link, org-insert-link-global) (org-open-at-point): Call `org-load-modules-maybe'. (org-search-view): Add more text properties. (org-agenda-schedule, org-agenda-deadline): Allow also in search-type agendas. (org-search-view): Order of arguments has been changed. Interpret prefix-arg as TODO-ONLY. (org-agenda, org-run-agenda-series, org-agenda-manipulate-query): Take new argument order of `org-search-view' into account. (org-todo-only): New variable. (org-search-syntax-table): New variable and function. (org-search-view): Do the search with the special syntax table. (define-obsolete-function-alias): Make work with XEmacs. (org-add-planning-info): Use old date as default when modifying an existing deadline or scheduled item. (org-agenda-compute-time-span): Make argument N optional. (org-agenda-format-date-aligned): Require `cal-iso'. (org-agenda-list): Include week into into agenda heading, don't list it at each date (only on Mondays). (org-read-date-analyze): Define local variable `iso-date'. (org-agenda-format-date-aligned): Remove dependency on `calendar-time-from-absolute'. (org-remember-apply-template, org-go-to-remember-target): Interpret filenames relative to `org-directory'. (org-complete): Silently fail when trying to complete keywords that don't have a default value. (org-get-current-options): Added a #+DATE: option. (org-additional-option-like-keywords): Removed "DATE:" from the list of additional keywords. (org-export-as-html): Removed (current-time) as unnecessary second argument of `format-time-string'. (org-clock-find-position): Handle special case at end of buffer. (org-agenda-day-view): New argument DAY-OF-YEAR, pass it on to `org-agenda-change-time-span'. (org-agenda-week-view): New argument ISO-WEEK, pass it on to `org-agenda-change-time-span'. (org-agenda-month-view): New argument MONTH, pass it on to `org-agenda-change-time-span'. (org-agenda-year-view): New argument YEAR, pass it on to `org-agenda-change-time-span'. (org-agenda-change-time-span): New optional argument N, pass it on to `org-agenda-compute-time-span'. (org-agenda-compute-time-span): New argument N, interpret it by changing the starting day. (org-small-year-to-year): New function. (org-scheduled-past-days): Respect `org-scheduled-past-days'. (org-auto-repeat-maybe): Make sure that repeating dates are pushed into the future, and that the shift is at least one interval, never 0. (org-update-checkbox-count): Fix bug with checkbox counting. (org-add-note): New command. (org-add-log-setup): Renamed from `org-add-log-maybe'. (org-log-note-headings): New entry for plain notes (i.e. notes not related to state changes or clocking). (org-get-org-file): Check for availability of `remember-data-file'. (org-cached-entry-get): Allow a regexp value for `org-use-property-inheritance'. (org-use-property-inheritance): Allow regexp value. Fix bug in customization type. (org-use-tag-inheritance): Allow a list and a regexp value for this variable. (org-scan-tags, org-get-tags-at): Implement selective tag inheritance. (org-entry-get): Respect value `selective' for the INHERIT argument. (org-tag-inherit-p, org-property-inherit-p): New functions. (org-agenda-format-date-aligned): Allow 10 characters for weekday, to acomodate German locale. (org-add-archive-files): New function. (org-agenda-files): New argument `ext', to get archive files as well. (org-tbl-menu): Protect the use of variables that are only available when org-table.el gets loaded. (org-read-agenda-file-list): Error if `org-agenda-files' is a single directory. (org-open-file): Allow a batch process to trigger waiting after executing a system command. (org-store-link): Link to headline when there is not target and no region in an org-mode buffer when creating a link. (org-link-types-re): New variable. (org-make-link-regexps): Compute `org-link-types-re'. (org-make-link-description-function): New option. (org-agenda-date, org-agenda-date-weekend): New faces. (org-archive-sibling-heading): New option. (org-archive-to-archive-sibling): New function. (org-iswitchb): New command. (org-buffer-list): New function. (org-agenda-columns): Also try the #+COLUMNS line in the buffer associated with the entry at point (or with the first entry in the agenda view). (org-modules): Add entry for org-bibtex.el. (org-completion-fallback-command): Moved into `org-completion' group. (org-clock-heading-function): Moved to `org-progress' group. (org-auto-repeat-maybe): Make sure that a note can be enforces if `org-log-repeat' is `note'. (org-modules): Allow additional symbols for external packages. (org-ctrl-c-ctrl-c): Allow for `org-clock-overlays' to be undefined. (org-clock-goto): Hide drawers after showing an entry with `org-clock-goto.' (org-shiftup, org-shiftdown, org-shiftright, org-shiftleft): Try also a clocktable block shift. (org-clocktable-try-shift): New function. (org-columns-hscoll-title): New function. (org-columns-previous-hscroll): New variable. (org-columns-full-header-line-format): New variable. (org-columns-display-here-title, org-columns-remove-overlays): Install `org-columns-hscoll-title' in post-command-hook. * org/org.el: Split into many small files. * org/org-agenda.el: New file, split off from org.el. * org/org-archive.el: New file, split off from org.el. * org/org-bbdb.el: New file. * org/org-bibtex.el: New file, split off from org.el. * org/org-clock.el: New file, split off from org.el. * org/org-colview.el: New file, split off from org.el. * org/org-compat.el: New file, split off from org.el. * org/org-exp.el: New file, split off from org.el. * org/org-faces.el: New file, split off from org.el. * org/org-gnus.el: New file, split off from org.el. * org/org-info.el: New file, split off from org.el. * org/org-infojs.el: New file. * org/org-irc.el: New file. * org/org-macs.el: New file, split off from org.el. * org/org-mew.el: New file. * org/org-mhe.el: New file, split off from org.el. * org/org-publish.el: New file, split off from org.el. * org/org-remember.el: New file, split off from org.el. * org/org-rmail.el: New file, split off from org.el. * org/org-table.el: New file, split off from org.el. * org/org-vm.el: New file, split off from org.el. * org/org-wl.el: New file, split off from org.el. 2008-04-27 Jason Riedy <jason@acm.org> * lisp/org-table.el (orgtbl-to-generic): Add a :remove-nil-lines parameter that supresses lines that evaluate to NIL. (orgtbl-get-fmt): New inline function for picking apart formats that may be lists. (orgtbl-apply-fmt): New inline function for applying formats that may be functions. (orgtbl-eval-str): New inline function for strings that may be functions. (orgtbl-format-line, orgtbl-to-generic): Use and document. (orgtbl-to-latex, orgtbl-to-texinfo): Document. (*orgtbl-llfmt*, *orgtbl-llstart*) (*orgtbl-llend*): Dynamic variables for last-line formatting. (orgtbl-format-section): Shift formatting to support detecting the last line and formatting it specially. (orgtbl-to-generic): Document :ll* formats. Set to the non-ll formats unless overridden. (orgtbl-to-latex): Suggest using :llend to suppress the final \\. (*orgtbl-table*, *orgtbl-rtn*): Dynamically bound variables to hold the input collection of lines and output formatted text. (*orgtbl-hline*, *orgtbl-sep*, *orgtbl-fmt*, *orgtbl-efmt*, (*orgtbl-lfmt*, *orgtbl-lstart*, *orgtbl-lend*): Dynamically bound format parameters. (orgtbl-format-line): New function encapsulating formatting for a single line. (orgtbl-format-section): Similar for each section. Rebinding the dynamic vars customizes the formatting for each section. (orgtbl-to-generic): Use orgtbl-format-line and orgtbl-format-section. (org-get-param): Now unused, so delete. (orgtbl-gather-send-defs): New function to gather all the SEND definitions before a table. (orgtbl-send-replace-tbl): New function to find the RECEIVE corresponding to the current name. (orgtbl-send-table): Use the previous two functions and implement multiple destinations for each table. * doc/org.texi (A LaTeX example): Note that fmt may be a one-argument function, and efmt may be a two-argument function. (Radio tables): Document multiple destinations. 2008-04-27 Carsten Dominik <dominik@science.uva.nl> * org/org-agenda.el (org-add-to-diary-list): New function. (org-prefix-has-effort): New variable. (org-sort-agenda-noeffort-is-high): New option. (org-agenda-columns-show-summaries) (org-agenda-columns-compute-summary-properties): New options. (org-format-agenda-item): Compute the duration of the item. (org-agenda-weekend-days): New variable. (org-agenda-list, org-timeline): Use the proper faces for dates in the agenda and timeline buffers. (org-agenda-archive-to-archive-sibling): New command. (org-agenda-start-with-clockreport-mode): New option. (org-agenda-clockreport-parameter-plist): New option. (org-agenda-clocktable-mode): New variable. (org-agenda-deadline-leaders): Allow a function value for the deadline leader. (org-agenda-get-deadlines): Deal with new function value. * lisp/org-clock.el (org-clock): New customization group. (org-clock-into-drawer, org-clock-out-when-done) (org-clock-in-switch-to-state, org-clock-heading-function): Moved into the new group. (org-clock-out-remove-zero-time-clocks): New option. (org-clock-out): Use `org-clock-out-remove-zero-time-clocks'. (org-dblock-write:clocktable): Allow a Lisp form for the scope parameter. (org-dblock-write:clocktable): Fixed bug with total time calculation. (org-dblock-write:clocktable): Request the unrestricted list of files. (org-get-clocktable): New function. (org-dblock-write:clocktable): Make sure :tstart and :tend can not only be strings but also integers (an absolute day number) and lists (m d y). * org/org-colview.el (org-columns-next-allowed-value) (org-columns-edit-value): Limit the effort for updatig in the agenda to recomputing a single file. (org-columns-compute): Only write property value if it has changed. This avoids raising the buffer-change-flag unnecessarily. (org-agenda-colview-summarize) (org-agenda-colview-compute): New functions. (org-agenda-columns): Call `org-agenda-colview-summarize'. * org/org-exp.el (org-export-run-in-background): New option. (org-export-icalendar): Allow a batch process to trigger waiting after executing a system command. (org-export-preprocess-string): Renamed-from `org-cleaned-string-for-export'. (org-export-html-style): Made target class look like normal text. (org-export-as-html): Make use of the better proprocessing in `org-cleaned-string-for-export'. (org-cleaned-string-for-export): Better treatment of heuristic targets, many more internal links will now work in HTML export. (org-get-current-options): Incorporate LINK_UP, LINK_HOME, and INFOJS. (org-export-inbuffer-options-extra): New variable. (org-export-options-filters): New hook. (org-infile-export-plist): Find also the settings keywords in `org-export-inbuffer-options-extra'. (org-infile-export-plist): Allow multiple #+OPTIONS lines and multiple #+INFOJS_OPT lines. (org-export-html-handle-js-options): New function. (org-export-html-infojs-setup): New option. (org-export-as-html): Call `org-export-html-handle-js-options'. Add autoload to all entry points. (org-skip-comments): Function removed. * org/org-table.el (org-table-make-reference): Extra parenthesis around single fields, to make sure that algebraic formulas get correctly interpreted by calc. (org-table-current-column): No longer interactive. * org/org-export-latex.el (org-export-latex-preprocess): Renamed from `org-export-latex-cleaned-string'. 2008-04-27 Bastien Guerry <bzg@altern.org> * org/org-publish.el (org-publish-get-base-files-1): New function. (org-publish-get-base-files): Use it. (org-publish-temp-files): New variable. Don't require 'dired-aux anymore. (org-publish-initial-buffer): New variable. (org-publish-org-to, org-publish): Use it. (org-publish-get-base-files-1): Bug fix: get the proper list of files when recursing thru a directory. (org-publish-get-base-files): Use the :exclude property to skip both files and directories.
author Carsten Dominik <dominik@science.uva.nl>
date Sun, 27 Apr 2008 18:33:39 +0000
parents cde444d03b82
children 606f2d163a64 e6db9ee945b8
line wrap: on
line source

#!/bin/sh
### quick-install-emacs --- do a halfway-decent job of installing emacs quickly

## Copyright (C) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008
##   Free Software Foundation, Inc.

## Author: Miles Bader <miles@gnu.org>

## This file is part of GNU Emacs.

## GNU Emacs is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3, or (at your option)
## any later version.

## GNU Emacs is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with GNU Emacs; see the file COPYING.  If not, write to the
## Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
## Boston, MA 02110-1301, USA.

### Commentary:

## This script is mainly intended for emacs maintainer or pretesters who
## install emacs very often.  See the --help output for more details.


PUBLIC_LIBSRC_BINARIES='b2m emacsclient etags ctags ebrowse'
PUBLIC_LIBSRC_SCRIPTS='grep-changelog rcs-checkin'

AVOID="CVS -DIC README COPYING ChangeLog ~ [.]orig$ [.]rej$ Makefile makefile stamp-subdir [.]cvsignore [.]arch-ids [{]arch[}] [.][cho]$ make-docfile testfile test-distrib"

# Prune old binaries lying around in the source tree
PRUNE=no
# Re-install files even if they already exist
FORCE=no
# Command verbose flag
VERBOSE=''

me="`basename $0`"

# Install commands (if the user specifies the `--verbose' option, it is
# passed to these commands, so that feature only works if these commands
# implement it too)
LINK='cp -lf'
COPY='cp -f'
REMOVE='rm -r'
MKDIR='mkdir -p'

# Used to execute commands once once we create them
EXEC='sh'

NAWK=/usr/bin/nawk

# avoid non-standard command output from non-C locales
unset LANG LC_ALL LC_MESSAGES

# Some messages
USAGE="Usage: $me [OPTION...] BUILD_TREE [PREFIX]"
TRY="Try "\`"$me --help' for more information."

# Parse command-line options
while :; do
  case "$1" in
    -n|--dry-run)
      EXEC=cat; shift;;
    -p|--prune)
      PRUNE=yes; shift;;
    -P|--no-prune)
      PRUNE=no; shift;;
    --prune-only)
      PRUNE=only; shift;;
    -f|--force)
      FORCE=yes; shift;;
    -v|--verbose)
      VERBOSE="-v"; shift;;
    --help)
      cat <<EOF
$USAGE
Install emacs quickly

  -n, --dry-run              print installation commands instead of
                             executing them

  -f, --force                install even files that haven't changed
  -v, --verbose              print messages describing what is done

  -p, --prune                prune old generated files
  -P, --no-prune             don't prune old generated files (default)
      --prune-only           prune old generated files, but don't install

      --help                 display this help and exit
      --version              output version information and exit

$me install emacs \`incrementally,' that is, it will
install only those files that have changed since the last time it was
invoked, and remove any obsolete files from the installation
directories.  It also uses hard-links into the source and build trees to
do the install, so it uses much less space than the default Makefile
install target; however, this also means that $me can
not install onto a disk partition other than the one on which the source
and build directories reside.

Optionally, $me can also remove old versions of
automatically generated files that are version-specific (such as the
versioned emacs executables in the \`src' directory, and the DOC-* files
in the \`etc' directory).  The latter action is called \`pruning,' and
can be enabled using the \`-p' or \`--prune' options.
EOF
      exit 0
      ;;
    --version)
      cat <<EOF
$me 1.6

Written by Miles Bader <miles@gnu.org>
EOF
      exit 0
      ;;
    -[^-]?*)
      # split concatenated single-letter options apart
      FIRST="$1"; shift
      set -- `echo $FIRST | sed 's/-\(.\)\(.*\)/-\1 -\2/'` "$@"
      ;;
    -*)
      echo 1>&2 "$me: unrecognized option "\`"$1'"
      echo 1>&2 "$TRY"
      exit 1
      ;;
    *)
      break;
  esac
done

LINK_CMD="$LINK $VERBOSE"
REMOVE_CMD="$REMOVE $VERBOSE"

case $# in
  1) BUILD="$1";;
  2) BUILD="$1"; prefix="$2";;
  *)
    echo 1>&2 "$USAGE"
    echo 1>&2 "$TRY"
    exit 1
    ;;
esac

if test ! -d "$BUILD"; then
  echo 1>&2 "$me: $BUILD: Build tree not found"
  exit 2
elif test ! -r "$BUILD/config.status"; then
  echo 1>&2 "$me: $BUILD: Not a proper build tree, config.status not found"
  exit 2
fi

CONFIG_STATUS="$BUILD/config.status"
get_config_var ()
{
  if ! sed -n "s/^s\(.\)@$1@\1\(|#_!!_#|\)*\(.*\)\1.*$/\3/p" $CONFIG_STATUS | sed q | grep ''
  then
    echo 1>&2 "$me: $1: Configuration variable not found in $CONFIG_STATUS"
    exit 4
  fi
}

test x"$SRC" = x && { SRC="`get_config_var srcdir`" || exit 4 ; }
test x"$prefix" = x && { prefix="`get_config_var prefix`" || exit 4 ; }
test x"$ARCH" = x && { ARCH="`get_config_var host`" || exit 4 ; }

VERSION=`grep 'defconst[	 ]*emacs-version' $SRC/lisp/version.el \
         | sed -e 's/^[^"]*"\([^"]*\)".*$/\1/'`

DST_SHARE="$prefix/share/emacs/$VERSION"
DST_BIN="$prefix/bin"
DST_LIBEXEC="$prefix/libexec/emacs/$VERSION/$ARCH"
DST_INFO="$prefix/info"

maybe_mkdir ()
{
  if ! test -d "$1"; then
    $MKDIR $VERBOSE "$1" 2>&1 | sed "s/^mkdir:/$me:/" 1>&2
  fi
}

maybe_mkdir "$DST_BIN"
maybe_mkdir "$DST_SHARE"
maybe_mkdir "$DST_SHARE/site-lisp"
maybe_mkdir "$DST_LIBEXEC"
maybe_mkdir "$DST_INFO"

(  # start of command-generating sub-shell

PRUNED=""
if test x"$PRUNE" != xno; then
  for D in `ls -1t $BUILD/etc/DOC-* | sed 1d`; do
    echo $REMOVE_CMD $D
    PRUNED="$PRUNED $D"
  done
  for D in `ls -1t $BUILD/src/emacs-$VERSION.* | sed 1d`; do
    echo $REMOVE_CMD $D
    PRUNED="$PRUNED $D"
  done
fi

test x"$PRUNE" = xonly && exit 0

maybe_emit_copy ()
{
  if test "$FORCE" = yes || ! cmp -s $1 $2; then
    echo $LINK_CMD $1 $2
  fi
}

maybe_emit_copy $BUILD/src/emacs $DST_BIN/emacs
maybe_emit_copy $BUILD/src/emacs $DST_BIN/emacs-$VERSION

for F in $PUBLIC_LIBSRC_BINARIES; do
  maybe_emit_copy $BUILD/lib-src/$F $DST_BIN/$F
done
for F in $PUBLIC_LIBSRC_SCRIPTS; do
  maybe_emit_copy $SRC/lib-src/$F $DST_BIN/$F
done

if test x"$SRC" = x"$BUILD"; then
  PFXS="$BUILD"
else
  PFXS="$SRC $BUILD"
fi

for SUBDIR in lisp leim etc lib-src info; do
  # defaults
  SHARED=no
  FORCED=''
  AVOID_PAT="`echo "($AVOID)" | tr ' ' '|'`"

  # Set subdir-specific values
  case $SUBDIR in
    lisp|leim)
      DST="$DST_SHARE/$SUBDIR"
      ;;
    etc)
      DST="$DST_SHARE/$SUBDIR"
      # COPYING is in the avoid list, but there should be a copy of it in
      # the install etc dir, so make that here.
      FORCED="$DST/COPYING"
      ;;
    lib-src)
      DST="$DST_LIBEXEC"
      AVOID_PAT="`echo "($AVOID ($PUBLIC_LIBSRC_BINARIES $PUBLIC_LIBSRC_SCRIPTS)\$)" | tr ' ' '|'`"
      ;;
    info)
      DST="$DST_INFO"
      SHARED=yes
      ;;
  esac

  for PFX in $PFXS; do
    if [ -d $PFX/$SUBDIR ]; then
      for DIR in `(cd $PFX/$SUBDIR; find . -type d -print | sed 's@^./@@')`; do
	if [ -d $DST/$DIR ]; then
	  echo Directory $DST/$DIR exists
	else
	  echo Directory $DST/$DIR non-existant
	  if [ "`echo $DIR | egrep -v "$AVOID_PAT"`" ]; then
	    maybe_mkdir $DST/$DIR
	  fi
	fi
      done
      diff -sqr $PFX/$SUBDIR $DST
    fi
  done | $NAWK '
BEGIN {
  src_pat = "^'"$SRC"'/'"$SUBDIR"'/"
  build_pat = "^'"$BUILD"'/'"$SUBDIR"'/"
  dst_pat = "^'"$DST"'/"
  dst_pfx = "'"$DST"'/"
  avoid_pat = "'"$AVOID_PAT"'"
  force = ("'"$FORCE"'" == "yes")
  shared = ("'"$SHARED"'" == "yes")
  init_bool_array(pruned, "'"$PRUNED"'")
  init_bool_array(forced, "'"$FORCED"'")
}
function init_bool_array(array, string,  a,k)
{
  split (string, a)
  for (k in a)
    array[a[k]] = 1
}
function install(src, dst)
{
  if (! (src in pruned)) {
    cp[src] = dst;
    from[dst] = src;
    delete rm[dst];
  }
}
function update(src, dst, copy)
{
  if (src in pruned) {
    rm[dst] = 1;
    delete from[dst]
  } else {
    if (copy)
      cp[src] = dst;
    from[dst] = src;
    delete rm[dst];
  }
}
function uninstall(dst)
{
  if (!(dst in from))
    rm[dst] = 1;
}
/^Directory / {
  if ($2 ~ avoid_pat) {
    if ($NF == "exists")
      uninstall($2)
  } else
    update(0, $2, 0)
  next
}
/^Files / {
  if ($4 ~ avoid_pat && !($4 in forced))
    uninstall($4)
  else if ($NF == "identical")
    update($2, $4, force)
  else
    update($2, $4, 1)
  next
}
/^Only /  {
  pfx = $3
  sub (/:$/, "/", pfx)

  if (pfx ~ dst_pat) {
    if (! shared)
      uninstall(pfx $4)
  } else {
    subdir = pfx
    if (subdir ~ src_pat)
      sub (src_pat, "", subdir)
    else
      sub (build_pat, "", subdir)

    dst = dst_pfx subdir $4
    if (! (dst ~ avoid_pat))
      install(pfx $4, dst)
  }
  next
}
END {
  for (f in rm)
    print "'"$REMOVE_CMD"' " f
  for (f in cp)
    print "'"$LINK_CMD"' " f " " cp[f]
}
'
done

) | eval $EXEC

# arch-tag: 9322b572-9755-4cf7-a67a-21e6505f1477